Skip site navigation (1)Skip section navigation (2)
Date:      Sun, 16 Jul 2017 08:50:48 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r321043 - user/pho/stress2/misc
Message-ID:  <201707160850.v6G8omo3049246@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Sun Jul 16 08:50:47 2017
New Revision: 321043
URL: https://svnweb.freebsd.org/changeset/base/321043

Log:
  Add a scenario for demonstrating memory leak of routetbl.
  
  Sponsored by:	Dell EMC Isilon

Added:
  user/pho/stress2/misc/routetbl.sh   (contents, props changed)

Added: user/pho/stress2/misc/routetbl.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/routetbl.sh	Sun Jul 16 08:50:47 2017	(r321043)
@@ -0,0 +1,63 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2017 Dell EMC Isilon
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Demonstrate memory leak of routetbl allegedly caused by use free() in
+# vfs_free_addrlist_af(), instead of rn_detachhead().
+# "routetbl grew 3868" seen on amd64.
+
+. ../default.cfg
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+pgrep -q mountd || exit 0
+mount | grep "on $mntpoint " | grep -q /dev/md && umount -f $mntpoint
+[ -c /dev/md$mdstart ] &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 128m -u $mdstart || exit 1
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+
+routetbl=`vmstat -m | grep routetbl | awk '{print $2}'`
+s=0
+start=`date +%s`
+while [ $((`date +%s` - start)) -lt 60 ]; do
+	mount /dev/md${mdstart}$part $mntpoint &&
+	    umount $mntpoint
+done
+routetbl=$((`vmstat -m | grep routetbl | awk '{print $2}'` - routetbl))
+[ $routetbl -gt 0 ] &&
+    { echo "routetbl grew $routetbl"; s=1; }
+
+for i in `jot 6`; do
+	mount | grep -q "on $mntpoint " || break
+	umount $mntpoint && break || sleep 10
+done
+[ $i -eq 6 ] && exit 1
+mdconfig -d -u $mdstart
+rm -rf /tmp/template
+exit $s



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201707160850.v6G8omo3049246>